<template>
  <q-page class="row justify-center bg-blue-grey-1 q-pa-xl">
    <editor-tiptap
      v-model="composing"
      :categories="categories"
      @save="save"
    />

    <json-pretty
      v-if="composing.doc && $store.state.session.QUASAR_ENV === 'development'"
      :text="composing.doc"
      class="col"
    />
  </q-page>
</template>

<script>
import EditorTiptap from '../../components/composing/editor-tiptap'
import FormRating from '../../components/composing/form-rating'
import JsonPretty from '../../components/core/json-pretty'
import { required } from 'vuelidate/lib/validators'

export default {
  name: 'PageComposing',
  components: {
    EditorTiptap,
    JsonPretty
  },
  props: {
    submit: {
      type: Boolean,
      required: true
    },
    rating: {
      type: Boolean,
      required: true
    }
  },
  asyncData: {
    composingDefault: {},
    async composing () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Compositions/${this.composingId}`,
          params: {
            filter: {
              fields: ['id', 'title', 'status', 'doc', 'topicId', 'comments', 'rating']
            }
          }
        }

        const Response = await this.$axios(axiosConfig).then(R => R.data)

        this.$emit('topic', Response.topicId)

        return Response
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    },
    categoriesDefault: [],
    async categories () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Categories',
          params: {
            filter: {
              fields: ['id', 'label', 'color'],
              where: { type: 'rating' }
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  validations: {
    composing: {
      status: {
        required
      },
      doc: {
        required
      },
      topicId: {
        required
      },
      rating: {
        required
      }
    }
  },
  computed: {
    composingId () {
      return Number(this.$route.params.id)
    }
  },
  watch: {
    submit (submit) {
      if (submit) {
        this.save()
      }
    },
    rating (rating) {
      if (rating) {
        this.$q.dialog({
          error: this.$v.composing.$error,
          info: this.composing.rating,
          component: FormRating,
          parent: this
        }).onOk((data) => {
          this.composing.rating = data
        }).onDismiss(() => {
          this.$v.composing.$reset()
          this.$emit('rated')
        })
      }
    }
  },
  methods: {
    async save () {
      this.$v.composing.$touch()

      if (this.$v.composing.$error) {
        this.$emit('submitted')
        this.$emit('error')

        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'PATCH',
          url: `/Compositions/${this.composingId}`,
          data: JSON.parse(JSON.stringify(this.composing))
        }

        axiosConfig.data.status = 'Corrigido'

        await this.$axios(axiosConfig)

        if (this.submit) {
          this.axiosSuccess('Correção enviada com sucesso', '/compositions')
        }
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$emit('submitted')
        this.$q.loading.hide()
      }
    }
  }
}
</script>
